Subject: Re: [PATCH net-next v4] net: psample: Introduce stubs to remove NIC driver dependency

From: Leon Romanovsky <[email-masked]>
Date: Mon, 8 Feb 2021 09:03:50 +0200

On Mon, Feb 01, 2021 at 08:08:37PM +0200, Ido Schimmel wrote:
> On Mon, Feb 01, 2021 at 09:37:11AM +0800, Chris Mi wrote:
> > Hi Ido,
> >
> > On 1/30/2021 10:42 PM, Ido Schimmel wrote:
> > > On Fri, Jan 29, 2021 at 12:30:09PM -0800, Jakub Kicinski wrote:
> > > > On Fri, 29 Jan 2021 14:08:39 +0800 Chris Mi wrote:
> > > > > Instead of discussing it several days, maybe it's better to review
> > > > > current patch, so that we can move forward :)
> > > > It took you 4 revisions to post a patch which builds cleanly and now
> > > > you want to hasten the review? My favorite kind of submission.
> > > >
> > > > The mlxsw core + spectrum drivers are 65 times the size of psample
> > > > on my system. Why is the dependency a problem?
> > > mlxsw has been using psample for ~4 years and I don't remember seeing a
> > > single complaint about the dependency. I don't understand why this patch
> > > is needed.
> > Please see Saeed's comment in previous email:
> >
> > "
> >
> > The issue is with distros who ship modules independently.. having a
> > hard dependency will make it impossible for basic mlx5_core.ko users to
> > load the driver when psample is not installed/loaded.
> >
> > I prefer to have 0 dependency on external modules in a HW driver.
> > "
>
> I saw it, but it basically comes down to personal preferences.

It is more than personal preferences. In opposite to the mlxsw which is
used for netdev only, the mlx5_core is used by other subsystems, e.g. RDMA,
so Saeed's request to avoid extra dependencies makes sense.

We don't need psample dependency to run RDMA traffic.

>
> >
> > We are working on a tc sample offload feature for mlx5_core. The distros
> > are likely to request us to do this. So we address it before submitting
> > the driver changes.
>
> Which distros? Can they comment here? mlxsw is in RHEL and I don't
> remember queries from them about the psample module.

There is a huge difference between being in RHEL and actively work with
partners as mlx5 does.

The open mailing list is not the right place to discuss our partnership
relations.

Thanks

> > Regards,
> > Chris